<template>
    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-header">
                    <h4>Add Company</h4>
                </div>
                <div class="card-body">
                    <form @submit="checkForm" @submit.prevent="create" >
                        <div class="row">
                            <p v-if="errors.length">
                                <b>Please correct the following error(s):</b>
                            <ul>
                                <li v-for="error in errors">{{ error }}</li>
                            </ul>
                            </p>

                            <div class="col-12 mb-2">
                                <div class="form-group">
                                    <label>Name</label>
                                    <input required maxlength="255" type="text" class="form-control" v-model="company.name">
                                </div>
                            </div>
                            <div class="col-12">
                                <button type="submit" class="btn btn-primary">Save</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    name:"add-company",
    data(){
        return {
            company:{
                name:""
            },
            errors:[]
        }
    },
    methods:{
        checkForm: function (e) {
            if (this.company.name) {
                return true;
            }

            this.errors = [];

            if (!this.company.name) {
                this.errors.push('Name required.');
            }

            e.preventDefault();
        },
        async create(){
            await this.axios.post('/api/company',this.company).then(response=>{
                this.$router.push({name:"companyList"})
            }).catch(error=>{
                if (error.response.status == 422){
                    this.errors = error.response.data.errors;
                }

            })
        }

    }
}
</script>
